#ifndef ALLCMNDS_H
#define ALLCMNDS_H

#endif // ALLCMNDS_H




    commands::commands()
    {
       // This is constructor
       for(int i=0;i<20;i++)
          regMem[i]=0;
       A=&(regMem[0]);
       for(int i=0;i<8;i++)
          workspace1[i]=workspace2[i]=workspace3[i]=0;
    }
    //finds the address corresponding to the location in the arrary regMem[2000]
    int commands::address(char ch)
    {
       int num =0;
       if(ch>=97)
          ch-=32;
       switch(ch)
       {
          case 'A': num=0;break;
          //num=1 for flag
          case 'B': num=2;break;
          case 'C': num=3;break;
          case 'D': num=4;break;
          case 'E': num=5;break;
          case 'H': num=6;break;
          case 'L': num=7;break;
          case 'S': num=8;break;
              //num=10 & 11 for PC
          case 'T': num=13;break;
       }
       return (num);
    }

    /******************************************************************/
    //converts a binary 8 digit array into corresponding value in base 10 and assigns this value
    //to a location as specified by the integer argument
    void commands::assignValue(int num, int workspace[8])
    {
       int value=0;
       for(int i=7;i>=0;i--)
          value+=workspace[i]*(pow(2.0,7-i));
       regMem[num]=value;
    }
    /******************************************************************/
    void commands::Split(int pc, int *v1, int *v2)
    {
       char hex[2][3]={""};
       char hexCh[5]={""};
       sprintf(hexCh,"%X",pc);
       hex[0][0]=hexCh[0];
       hex[0][1]=hexCh[1];
       hex[1][0]=hexCh[2];
       hex[1][1]=hexCh[3];
       sscanf(hex[0],"%X",v1);
       sscanf(hex[1],"%X",v2);
    }
    /******************************************************************/
    //sets all the flags viz, Z,S,P,AC,CY.
    void commands::SetFlag(int arr[],int cy, int ac)
    {
       //Setting Flag S
        workspace3[0]= arr[0];
       //Setting Flag Z
       int count=0;
       for (int i=0;i<8;i++)
       {
          if(arr[i]==0)
             continue;
          count++;
       }
       if(count==0)
          workspace3[1]=1;
       //setting Flag P
       count=0;
       for (int i=0;i<8;i++)
       {
          if(arr[i]==1)
             count++;
       }
       if(count%2==0)
          workspace3[5]=1;
       //setting flag CY and AC
       workspace3[7]=cy;
       workspace3[3]=ac;
       assignValue(1,workspace3);
    }

    /******************************************************************/
    //converts a base 10 number into a binary array
    void commands::binaryArr(int num,int workspace[8])
    {

       int v=regMem[num];
       int count=7;
       while(count>=0)
       {
          workspace[count]=v%2;
          v/=2;
          count--;
       }
    }

    /******************************************************************/
    //The following functions bear the same name as the commands in Intel 8085
    //The specifications of these commands are dealt in greater depth in the documentation attached
    void commands::ADD(char ch)
    {
       int num = address(ch);
       binaryArr(0,workspace1);
       binaryArr(num,workspace2);
       int c[9]={0};
       unsigned char temp;
       for(int i=7;i>=0;i--)
       {
          temp=workspace1[i] + workspace2[i]+c[i+1];
          workspace1[i]= temp%2;
          c[i]=temp/2;
       }
       assignValue(0,workspace1);
       SetFlag(workspace1,c[0],c[4]);
    }

    /******************************************************************/
    void commands::ADC(char ch)
    {
       int num=address(ch);
       binaryArr(0,workspace1);
       binaryArr(num,workspace2);
       binaryArr(1,workspace3);
       int i;
       unsigned char temp;
       if(workspace3[7]==0)
       {
          ADD(ch);
       }
       else
       {
          int c;
          temp = workspace1[7]+workspace2[7]+1;
          workspace1[7]=temp%2;
          c=temp/2;
          for(i=6;i>=0;i--)
          {
             temp=workspace1[i]+workspace2[i]+c;
             workspace1[i]=temp%2;
             c=temp/2;
             if(i==4)
             {
                ac=c;
             }
          }
          cy=c;
          SetFlag(workspace1,cy,ac);
       }
    }

    /******************************************************************/
    void commands::ANA (char ch)
    {
       int num=address (ch);
       Reg = regMem[num];
       unsigned char temp;
       temp = regMem[0]|Reg;
       *A = temp;
       binaryArr(0,workspace1);
       //setting all flags
       SetFlag(workspace1,0,1);
    }

    /******************************************************************/
    void commands::ORA (char ch)
    {
       int num=address (ch);
       Reg=regMem[num];
       unsigned char temp;
       temp= *A|Reg;
       *A= temp;
       binaryArr(0,workspace1);
       //setting all flags
       SetFlag(workspace1,0,0);
    }

    /******************************************************************/
    void commands::XRA(char ch)
    {
       int num=address (ch);
       Reg=regMem[num];
       unsigned char temp;
       temp=*A^Reg;
       *A=temp;
       binaryArr(0,workspace1);
       SetFlag(workspace1,0,0);
    }

    /******************************************************************/
    void commands::MOV(char ch1, char ch2)
    {
       int num1 =address(ch1);
       int num2 =address(ch2);
       regMem[num1]=regMem[num2];
    }

    /******************************************************************/
    void commands::MVI(char ch, int val)
    {
       int num =address(ch);
       regMem[num]=val;
    }

    /******************************************************************/
    void commands::ACI(int val)
    {
       regMem[13]=val;
       ADC('T');
    }

    /******************************************************************/
    void commands::ADI(int val)
    {
       regMem[13]=val;
       ADD('T');
    }


    /******************************************************************/
    void commands::SUB(char ch)
    {
       int num=address(ch);
       Reg=regMem[num];
       unsigned char temp;
       temp=(~Reg)+1;
       Reg=temp;
       ADI((int)Reg);
       workspace3[7]= (workspace3[7]==0)?1:0;
       assignValue(1,workspace3);
    }

    /******************************************************************/
    void commands::CMP(char ch)
    {
       unsigned char temp;
       temp=*A;
       SUB(ch);
       *A= temp;
    }

    /******************************************************************/
    void commands::INR(char ch)
    {
       cy=workspace3[7];
       unsigned char temp;
       if(ch=='A' || ch== 'a')
          ADI(1);
       else
       {
          temp=*A;
          int num=address(ch);
          *A=1;
          ADD(ch);
          regMem[num]=*A;
          workspace3[7]=cy;
          *A=temp;
          assignValue(1,workspace3);
       }
    }

    /******************************************************************
    void commands::printAll()
    {
            //cout<<"A="<<hex<<(int)regMem[0]<<endl;
            //cout<<"B="<<hex<<(int)regMem[2]<<endl;
            //cout<<"C="<<hex<<(int)regMem[3]<<endl;
            //cout<<"D="<<hex<<(int)regMem[4]<<endl;
            //cout<<"Flags: S,Z,AC,P,CY"<<endl<<"       ";
            binaryArr(1,workspace3);
            for(int i=0;i<8;i++)
            {
                    if((i!=2)&&(i!=4)&&(i!=6))
                    {
                            if((i==3)||(i==7))//cout<<" ";
                            //cout<<workspace3[i];
                            if(i!=7)//cout<<",";
                    }
            }
            //cout<<"\n\n\n\n"<<endl;
    }
    /******************************************************************/
    void commands::CPI(int val)
    {
       unsigned char temp;
       temp = *A;
       SUI(val);
       *A = temp;
    }
    /******************************************************************/
    void commands::ANI (int val)
    {
       regMem[13] = val;
       ANA('T');
    }
    /******************************************************************/
    void commands::ORI (int val)
    {
       regMem[13] = val;
       ORA('T');
    }
    /******************************************************************/
    void commands::XRI (int val)
    {
       regMem[13] = val;
       XRA('T');
    }
    /******************************************************************/
    void commands::SUI (int val)
    {
       regMem[13] = val;
       SUB('T');
    }
    /******************************************************************/
    void commands::DCR (char ch)
    {
       unsigned char temp;
       if(ch=='A' || ch=='a')
          SUI(1);
       else
       {
          temp = *A;
          int num=address(ch);
          *A=regMem[num];
          SUI(1);
          regMem[num]=*A;
          *A=temp;
       }
    }
    /******************************************************************/
    void commands::CMA()
    {
       unsigned char temp;
       temp= ~(*A);
       *A=temp;
    }
    /******************************************************************/
    void commands::CMC()
    {
        regMem[1]=regMem[1]%2==0?regMem[1]+1:regMem[1]-1;
    }
    /******************************************************************/
    void commands::XCHG()
    {
        regMem[13]=regMem[4];
        regMem[4]=regMem[6];
        regMem[6]=regMem[13];

        regMem[13]=regMem[5];
        regMem[5]=regMem[7];
        regMem[7]=regMem[13];
    }
    /******************************************************************/
    void commands::LXI(char ch,int val)
    {
        int num=address(ch);
        int *v1,*v2;
        Split(val,v1,v2);
        regMem[num]=*v1;
        regMem[num+1]=*v2;
    }
    /******************************************************************/
    void commands::SPHL()
    {
        regMem[8]=regMem[6];
        regMem[9]=regMem[7];
    }
    /******************************************************************/
    void commands::LDAX(char ch)
    {
       int num=address(ch);
       int val=regMem[num]*16*16+regMem[num+1];
       regMem[0]=memory[val];
    }
    /******************************************************************/
    void commands::LHLD(int val)
    {
       regMem[7]=memory[val];
       regMem[6]=memory[val+1];
    }
    /******************************************************************/
    void commands::LDA(int val)
    {
       regMem[0]=memory[val];
    }
    /******************************************************************/
    void commands::STAX(char ch)
    {
       int num=address(ch);
       int val=regMem[num]*16*16+regMem[num+1];
       memory[val]=regMem[0];
    }
    /******************************************************************/
    void commands::SHLD(int val)
    {
       memory[val]=regMem[7];
       memory[val+1]=regMem[6];
    }
    /******************************************************************/
    void commands::STA(int val)
    {
       memory[val]=regMem[0];
    }
    /******************************************************************/
    void commands::XTHL()
    {
       int val=regMem[8]*16*16+regMem[9];
       regMem[13]=memory[val];
       memory[val]=regMem[7];
       regMem[7]=regMem[13];
       regMem[13]=memory[val+1];
       memory[val+1]=regMem[6];
       regMem[6]=regMem[13];
    }
    /******************************************************************/
    void commands::POP(char ch)
    {
       int num=address(ch);
       int val=regMem[8]*16*16+regMem[9];
       regMem[num+1]=memory[val];
       regMem[num]=memory[val+1];
       int *v1,*v2;
       Split(val+2,v1,v2);
       regMem[8]=*v1;
       regMem[9]=*v2;
    }
    /******************************************************************/
    void commands::PUSH(char ch)
    {
       int num=address(ch);
       int val=regMem[8]*16*16+regMem[9];
       memory[val-1]=regMem[num];
       memory[val-2]=regMem[num+1];
       int *v1,*v2;
       Split(val+2,v1,v2);
       regMem[8]=*v1;
       regMem[9]=*v2;
    }
    /******************************************************************/
    void commands::SBB(char ch)
    {
       binaryArr(1,workspace3);
       unsigned char temp;
       temp = regMem[1];
       if(workspace3[7]==1)
          INR(ch);
       SUB(ch);
    }
    /******************************************************************/
    void commands::SBI(int val)
    {
       regMem[13]=val;
       SBB('Z');
    }
    /******************************************************************/
    void commands::STC()
    {
       regMem[1]= regMem[1]%2==0?regMem[1]+1:regMem[1];
    }
    /******************************************************************/
    void commands::INX(char ch)
    {
       unsigned char flag;
       int num = address(ch);
       flag = (regMem[num+1]==255) ? 1:0;
       regMem[num+1]+=1;
       if(flag==1)
          regMem[num]+=1;
    }
    /******************************************************************/
    void commands::DCX(char ch)
    {
       unsigned char flag;
       int num = address(ch);
       flag = (regMem[num+1]==255) ? 1:0;
       regMem[num+1]-=1;
       if(flag==1)
          regMem[num]-=1;
    }
    /******************************************************************/
    void commands::DAD(char ch)
    {
       unsigned char flag=0,cy=0;
       int num=address(ch);
       if((int)regMem[num+1] + (int)regMem[6]>255)
          flag=1;
       regMem[6]+=regMem[num+1];
       if((int)regMem[num] + (int)regMem[5]+ (int)flag>255)
          cy=1;
       regMem[5]+=(regMem[num]+flag);
       STC();
       if(cy==0)
       CMC();
    }


    /******************************************************************/
    void commands::DAA()
    {
       binaryArr(0,workspace1);
       int num=0;
       if(workspace1[0]==1)
          num+=96;
       if(workspace1[4]==1)
          num+=6;
       ADI(num);
    }

    /******************************************************************/
    void commands::RLC()
    {
       binaryArr(0,workspace1);
       binaryArr(1,workspace3);
       int temp=workspace1[0];
       for(int i=0;i<=6;i++)
          workspace1[i]=workspace1[i+1];
       workspace1[7]=workspace3[7]=temp;
       STC();
       if(workspace3[7]==0)
          CMC();
    }
    /******************************************************************/
    void commands::RRC()
    {
       binaryArr(0,workspace1);
       binaryArr(1,workspace3);
       int temp=workspace1[7];
       for(int i=6;i>=0;i--)
          workspace1[i+1]=workspace1[i];
       workspace1[0]=workspace3[7]=temp;
       STC();
       if(workspace3[7]==0)
          CMC();
    }
    /******************************************************************/
    void commands::RAL()
    {
       binaryArr(0,workspace1);
       binaryArr(1,workspace3);
       int temp=workspace1[0];
       for(int i=0;i<=6;i++)
          workspace1[i]=workspace1[i+1];
       workspace1[7]=workspace3[7];
       workspace3[7]=temp;
       STC();
       if(workspace3[7]==0)
          CMC();
    }
    /******************************************************************/
    void commands::RAR()
    {
       binaryArr(0,workspace1);
       binaryArr(1,workspace3);
       int temp=workspace1[7];
       for(int i=6;i>=0;i--)
          workspace1[i+1]=workspace1[i];
       workspace1[0]=workspace3[7];
       workspace3[7]=temp;
       STC();
       if(workspace3[7]==0)
          CMC();
    }
    /******************************************************************/
    int commands::JMP()
    {
       return 1;
    }
    /******************************************************************/
    int commands::JNZ()
    {
       binaryArr(1,workspace3);
       return (workspace3[1]==0);
    }
    /******************************************************************/
    int commands::JZ()
    {
       binaryArr(1,workspace3);
       return (workspace3[1]==1);
    }
    /******************************************************************/
    int commands::JNC()
    {
       binaryArr(1,workspace3);
       return (workspace3[7]==0);
    }
    /******************************************************************/
    int commands::JC()
    {
       binaryArr(1,workspace3);
       return (workspace3[7]==1);
    }
    /******************************************************************/
    int commands::JPO()
    {
       binaryArr(1,workspace3);
       return (workspace3[5]==0);
    }
    /******************************************************************/
    int commands::JPE()
    {
       binaryArr(1,workspace3);
       return (workspace3[5]==1);
    }
    /******************************************************************/
    int commands::JP()
    {
       binaryArr(1,workspace3);
       return (workspace3[0]==0);
    }
    /******************************************************************/
    int commands::JM()
    {
       binaryArr(1,workspace3);
       return (workspace3[0]==1);
    }
    /******************************************************************/
    int commands::CALL()
    {
       return 1;
    }
    /******************************************************************/
    int commands::CNZ()
    {
       binaryArr(1,workspace3);
       return (workspace3[1]==0);
    }
    /******************************************************************/
    int commands::CZ()
    {
       binaryArr(1,workspace3);
       return (workspace3[1]==1);
    }
    /******************************************************************/
    int commands::CNC()
    {
       binaryArr(1,workspace3);
       return (workspace3[7]==0);
    }
    /******************************************************************/
    int commands::CC()
    {
       binaryArr(1,workspace3);
       return (workspace3[7]==1);
    }
    /******************************************************************/
    int commands::CPO()
    {
       binaryArr(1,workspace3);
       return (workspace3[5]==0);
    }
    /******************************************************************/
    int commands::CPE()
    {
       binaryArr(1,workspace3);
       return (workspace3[5]==1);
    }
    /******************************************************************/
    int commands::CP()
    {
       binaryArr(1,workspace3);
       return (workspace3[0]==0);
    }
    /******************************************************************/
    int commands::CM()
    {
       binaryArr(1,workspace3);
       return (workspace3[0]==1);
    }
    /******************************************************************/
    int commands::RET()
    {
       return 1;
    }
    /******************************************************************/
    int commands::RNZ()
    {
       binaryArr(1,workspace3);
       return (workspace3[1]==0);
    }
    /******************************************************************/
    int commands::RZ()
    {
       binaryArr(1,workspace3);
       return (workspace3[1]==1);
    }
    /******************************************************************/
    int commands::RNC()
    {
       binaryArr(1,workspace3);
       return (workspace3[7]==0);
    }
    /******************************************************************/
    int commands::RC()
    {
       binaryArr(1,workspace3);
       return (workspace3[7]==1);
    }
    /******************************************************************/
    int commands::RPO()
    {
       binaryArr(1,workspace3);
       return (workspace3[5]==0);
    }
    /******************************************************************/
    int commands::RPE()
    {
       binaryArr(1,workspace3);
       return (workspace3[5]==1);
    }
    /******************************************************************/
    int commands::RP()
    {
       binaryArr(1,workspace3);
       return (workspace3[0]==0);
    }
    /******************************************************************/
    int commands::RM()
    {
       binaryArr(1,workspace3);
       return (workspace3[0]==1);
    }
    /******************************************************************/

